#!/usr/bin/perl
####cerTainting alpha ch. of RGB image, with certainty[grey=.299r+.587g+.114b]
# certaint.pl taints images with doubt (calls certaint.c repeatedly)

# output is always png

# handles NaN properly, therefore we should pchirp2nocrop first then certaint

# input can be pnm or png, BUT IF INPUT IS A PNG, IT MUST HAVE AN ALPHA CHANNEL

# therefore pchirp2nocrop -png first and THEN run certaint
# because pchirp2nocrop won't preserve the certaint

if ($#ARGV < 0) {
  printf("Use: certaint.pl v???.jpg # or use gash\n");
  printf("     certaint.pl autodetects jpg, pgm, ppm, or png input\n");
  printf("     certaint.pl BUT IF INPUT IS PNG, IT MUST HAVE ALPHA CHANNEL\n");
  printf("     certaint.pl (input alpha ch. treated as binary certainty)\n");
  printf("     certaint.pl if input is pnm, certaint.c tests for offsets\n");
  printf("     certaint.pl and existence of offsets indicate that myNaN=255\n");
  printf("     certaint.pl output is always png with a certainty channel\n");
  printf("     certaint.pl C=0 denotes NaN; C=1..255 indicates numberness\n");
  printf("     certaint.pl (certainty) of grey or RGB channels\n");
  die "     ERROR: YOU MUST SPECIFY SOME FILENAMES TO BE DECHIRPED$!\n";
}

#printf("\n");
for ($counter=0; $counter<=$#ARGV+1-1; $counter++) {
  # $#ARGV is -1 if no arguments given; is 0 if 1 argument given, etc...
  # e.g. $#ARGV is one less than number of input files, so go 0..$#ARGV
  $filein = $ARGV[$counter];
  $periodposition = rindex($filein,"."); # right index, period from right
  $postfix = substr($filein,$periodposition+1,3); # 2 char, e.g. JP or jp
  $postfix =~ tr/[A-Z]/[a-z]/;

  $fileout = substr($filein,0,$periodposition); # before period
  $fileout = $fileout."t".".png"; # e.g. v000t.png, v001t.png, etc...
#  printf("fileout is %s\n", $fileout);

  #if input is JPEG, jpeg, JPG, or jpg:
  if (($postfix eq "jpg") || ($postfix eq "jpe")) {
     `djpeg $filein > deleteme_deleteme.pnm`;
     $filein = "deleteme_deleteme.pnm";
  }

  printf("certaint.pl: about to taint $fileout with uncertainty of $filein\n");
#  system("certaint $filein $fileout");
  `certaint $filein $fileout`;
}

