#!/usr/bin/perl
#est_pairwise.pl

# number of steps is specified here, e.g. $steps = sprintf("4 8 7 6 5");
# does 8 steps at lowest resolution, 7 next, then 6, and finally 5 at max res

# $steps = sprintf("4 3 3 3 3"); # does 3 repetitions at each of 4 levels
# $steps = sprintf("4 4 3 2 1"); # does 4 then 3 then 2, then 1 (1 means none)

# except in rare and strange cases, more reps at each step gives better fit
# also, insanely large numbers of steps are good for demos: severe overkill
# but makes it stay on screen long enough to see, during a lecture demonstration

# in certain rare marginal cases if you do too many at beginning it won't work,
# e.g. i once shot video with a defective eyetap, and
# $steps = sprintf("5 32 16 8 4 2"); did not work, even though 5 4 4 4 4 4 did!

# here are some examples of what i've done in the past for eyetap video;
# just uncomment the one you want to try:
# $steps = sprintf("5 8 4 4 4 4"); #usually better because you more at low res
# $steps = sprintf("4 8 32 8 2");
# $steps = sprintf("3 32 8 2");
$steps = sprintf("3 64 16 1");

$FILEOUT = sprintf("parameters_pairwise.txt"); # outfile accumulates all pairs
`rm $FILEOUT`; # initialize to empty

#$firstframe=90; $lastframe=112;
#e.g. if there are 250 frames numbered 0 to 249, enter 249

#$firstframe=97; $lastframe=98;
#$firstframe=86; $lastframe=119;

$firstframe=$ARGV[0];
$lastframe=$ARGV[1];
$skipframes=$ARGV[2];

$prefix="orbit2/v";  # directory as well as part of file before number
#$postfix=".pgm";
$postfix=".jpg";

printf("\n");
for ($counter=$firstframe+1; $counter<=$lastframe; $counter++) {
  $filea = sprintf("$prefix%04d$postfix", $counter-1);
  $fileb = sprintf("$prefix%04d$postfix", $counter);

  $fileout = sprintf("porkparameters%03d_%03d.txt", $counter,$counter-1);
  # last line of above file is the final answer
  # above file is cumulative result

  printf("about to djpeg $filea and $fileb\n");
  `djpeg -grayscale $filea > deleteme_deletemea.pgm`;
  `djpeg -grayscale $fileb > deleteme_deletemeb.pgm`;
  printf("about to estpchirp2m\n");
  `estpchirp2m deleteme_deletemea.pgm deleteme_deletemeb.pgm -outp $fileout -display $steps > pork_stdout.txt`;

  # cat files together
  `tail -1 $fileout >> FILEOUT`;  # cat into at first empty, accumulation
}

