#!/usr/bin/perl
#est_pairwise.pl

# number of steps is specified here, e.g. $steps = sprintf("4 8 7 6 5");
# does 8 steps at lowest resolution, 7 next, then 6, and finally 5 at max res

# $steps = sprintf("4 3 3 3 3"); # does 3 repetitions at each of 4 levels
# $steps = sprintf("4 4 3 2 1"); # does 4 then 3 then 2, then 1 (1 means none)

# except in rare and strange cases, more reps at each step gives better fit
# also, insanely large numbers of steps are good for demos: severe overkill
# but makes it stay on screen long enough to see, during a lecture demonstration

# in certain rare marginal cases if you do too many at beginning it won't work,
# e.g. i once shot video with a defective eyetap, and
# $steps = sprintf("5 32 16 8 4 2"); did not work, even though 5 4 4 4 4 4 did!

# here are some examples of what i've done in the past for eyetap video;
# just uncomment the one you want to try:
# $steps = sprintf("5 8 4 4 4 4"); #usually better because you more at low res
# $steps = sprintf("4 8 32 8 2");
#$steps = sprintf("3 32 18 2");
#$steps = sprintf("3 2 1 0");
#$steps = sprintf("3 64 16 1");
$steps = sprintf("3 16 4 1");
#$local_steps = sprintf("2 3 5");
$local_steps = sprintf("1 8");

if ($#ARGV < 0) {
  printf("Use: estpairwise v???.jpg # or use gash\n");
  printf("     estpairwise also autodetects jpg or ppm\n");
     die "     ERROR: YOU MUST SPECIFY SOME FILENAMES TO BE ESTimated$!\n";
}

$FILEOUT = sprintf("parameters_pairwise.txt"); # outfile accumulates all pairs
$ROUGHPAIRWISE = sprintf("tmp_ROUGH_params.txt"); # accumulates all pairs
`touch $FILEOUT`;
`touch $ROUGHPAIRWISE`;
`rm $FILEOUT`; # initialize to empty
`rm $ROUGHPAIRWISE`; # initialize to empty
##`touch $FILEOUT`;

$RESTABILIZE_NUMBER=15;
$SKIPNUM=1;


`cp mediator.ppm  tmp_mediator.ppm`;
`cp corners.txt   tmp_cornersa.txt`;
$corners = `tail -1 tmp_cornersa.txt`;

for ($counter=0; $counter<=$#ARGV+1-2; $counter++) {
# $#ARGV is -1 if no arguments given; is 0 if 1 argument given, etc...
  $filea = $ARGV[$SKIPNUM*$counter];
  $counterplusone = $counter+1;
  $fileb = $ARGV[$SKIPNUM*$counterplusone];

  $reference_position = 0;

  $fileout = sprintf("porkparameters%03d_%03d.txt", $counter+1,$counter);
  # last line of above file is the final answer
  # above file is cumulative result

  $periodpositiona = rindex($filea,"."); # right index, period from right
  $periodpositionb = rindex($fileb,".");
  $postfixa = substr($filea,$periodpositiona+1,3); # 2 char, e.g. JP or jp
  $postfixa =~ tr/[A-Z]/[a-z]/;
  #print $postfixa;
  $postfixb = substr($fileb,$periodpositionb+1,3);
  $postfixb =~ tr/[A-Z]/[a-z]/;
  #print $postfixb;
  #if it's JPEG, jpeg, JPG, or jpg:
    if (($postfixa eq "jpg") || ($postfixa eq "jpe")) { 
      #printf("about to djpeg $filea\n");
      `djpeg -grayscale $filea > deleteme_deletemea.pgm`;
      #$filea = "deleteme_deletemea.pgm";
      `djpeg $filea > deleteme_deletemea.ppm`;
    }
    else {
      # QUICK HACK ASSUMES PPM
      `cp $filea deleteme_deletemea.ppm`; 
      `ppmtopgm $filea > deleteme_deletemea.pgm`
    }

  if( $counter%$RESTABILIZE_NUMBER == 0 ) {
    $reference_position = $counter;
    printf("*****SAVING REFERENCE FRAME: $filea ******\n");
    `cp deleteme_deletemea.pgm tmp_reference_frame.pgm`; 
    `cp deleteme_deletemea.ppm tmp_reference_frame.ppm`; 
  }

  #if it's JPEG, jpeg, JPG, or jpg:
    if (($postfixb eq "jpg") || ($postfixb eq "jpe")) { 
      #printf("about to djpeg $fileb\n");
      `djpeg -grayscale $fileb > deleteme_deletemeb.pgm`;
      #$fileb = "deleteme_deletemeb.pgm";
      `djpeg $fileb > deleteme_deletemeb.ppm`;
    }
    else {
      # QUICK HACK ASSUMES PPM
      `cp $fileb deleteme_deletemeb.ppm`; 
      `ppmtopgm $fileb > deleteme_deletemeb.pgm`
    }

  # now it's a PNM, pnm, PPM, ppm, PGM, or pgm:
  printf("estpairwise.pl: about to estpchirp2m $filea $fileb -outp $fileout -display -steps $steps\n");

  printf("estpchirp2m deleteme_deletemea.pgm deleteme_deletemeb.pgm -outp $fileout -display -steps $steps > pork_stdout.txt\n");
  # this will be our initial guess as to where the ad moves
  ##`estpchirp2m deleteme_deletemea.pgm deleteme_deletemeb.pgm -outp $fileout -display -steps $steps > pork_stdout.txt`;
  `estpchirp2m deleteme_deletemea.pgm deleteme_deletemeb.pgm -outp $fileout -steps $steps > pork_stdout.txt`;

  $printout_params = `tail -1 $fileout`;
  printf("GOT $printout_params\n");
  # cat files together
  # these parameters will track the ad well, not necessarily all ads
  #`tail -1 $fileout >> $FILEOUT`;  # cat into at first empty, accumulation
  `cp $FILEOUT $ROUGHPAIRWISE`;
  `tail -1 $fileout >> $ROUGHPAIRWISE`;  # cat into at first empty, accumulation
  ##DECIDE TO USE IF NAN MOTION IS MINOR
  `tail -1 $fileout >> $FILEOUT`;  # cat into at first empty, accumulation

  #estimate chirp to reference frame
  printf("about to pintegrate $ROUGHPAIRWISE 0  > tmp_Params.txt\n");
  `pintegrate $ROUGHPAIRWISE 0 > tmp_Params.txt`;
  ##`pintegrate $ROUGHPAIRWISE $reference_position > tmp_Params.txt`;
  $chirp_to_ref = `tail -1 tmp_Params.txt`;
  chomp($chirp_to_ref);

  #estimate vs absolute reference frame (no drift problem)
  printf("estpairwise.pl: about to estpchirp2m tmp_reference_frame.pgm deleteme_deletemeb.pgm -outp $fileout -display -steps $steps -pin $chirp_to_ref > pork_stdout.txt\n");
 ## `estpchirp2m tmp_reference_frame.pgm deleteme_deletemeb.pgm -outp $fileout -display -steps $steps -pin $chirp_to_ref > pork_stdout.txt`;
  `estpchirp2m tmp_reference_frame.pgm deleteme_deletemeb.pgm -outp $fileout -steps $steps -pin $chirp_to_ref > pork_stdout.txt`;

  $global_chirp_parameters = `tail -1 $fileout`;
  chomp($global_chirp_parameters);



  ########BEGIN NANMASK ESTIMATION, RELATIVE TO REF##############
  # perform this the get rid of 255,255,255 values in images
  `pchirp2nocrop tmp_reference_frame.pgm tmpad.pgm 1 0 0 0 1 0 0 0`;
  `pchirp2nocrop deleteme_deletemeb.pgm tmpbd.pgm 1 0 0 0 1 0 0 0`;

  
  ##project the points to image a coordinates
  $rechirp_params_a  = `corners2r_main $corners`;
  `pchirp2nocrop mediator.pgm tmp_mediatora.pgm $rechirp_params_a`;
  `cement -nanmask deleteme_maskeda.pgm tmpad.pgm tmp_mediatora.pgm`;

  ##project the points to image b coordinates
  printf("about to p_of_points $global_chirp_parameters $corners\n");
  $rechirp_corners = `p_of_points $global_chirp_parameters $corners`;
  ##calulate how we have to rechirp the mediating image
  $rechirp_params  = `corners2r_main $rechirp_corners`;
  ##rechirp the mediating image
  `pchirp2nocrop mediator.pgm tmp_mediatorb.pgm $rechirp_params`;
  #create NANmasked images
  `cement -nanmask deleteme_maskedb.pgm tmpbd.pgm tmp_mediatorb.pgm`;

  # now use the nanmasked images, with a first guess as well
  # this will really help zero in on the motion of the ad
  ##`estpchirp2m deleteme_maskeda.pgm deleteme_maskedb.pgm -nanmask -outp $fileout -display -steps $local_steps -pin $global_chirp_parameters > pork_stdout.txt`;
  `estpchirp2m deleteme_maskeda.pgm deleteme_maskedb.pgm -nanmask -outp $fileout  -steps $local_steps -pin $global_chirp_parameters > pork_stdout.txt`;

  $local_chirp_parameters = `tail -1 $fileout`;
  ##these aren't pairwise anymore, they are relative to last reference frame!
  ##bad`tail -1 $fileout >> $FILEOUT`;  # cat into at first empty, accumulation
  chomp($local_chirp_parameters);
  #####END NANMASK ESTIMATION#######################



  #printf("about to p_of_points $global_chirp_parameters $corners\n");
  printf("about to p_of_points $local_chirp_parameters $corners\n");
  $rechirp_corners = `p_of_points $local_chirp_parameters $corners`; 
  ##calulate how we have to rechirp the mediating image
  $rechirp_params  = `corners2r_main $rechirp_corners`;

  # now write out some nice images! 
  $prefixb = substr($fileb,0,$periodpositiona);

  $fileoutb = "d".$prefixb.".pnm";
  `pchirp2nocrop deleteme_deletemeb.ppm tmpbd.ppm 1 0 0 0 1 0 0 0`;
  `pchirp2nocrop mediator.ppm tmp_mediatorb.ppm $rechirp_params`;
  printf("Writing $fileoutb\n");
 `cement -overlay $fileoutb tmpbd.ppm tmp_mediatorb.ppm`;

  #update corners for next image if needed for next iteration
  if( ($counter+1)%$RESTABILIZE_NUMBER == 0 ) {
    printf("****ANTICIPATING NEW REFERENCE FRAME*******\n");
    $rechirp_corners = `p_of_points $local_chirp_parameters $corners`;
    $corners = $rechirp_corners;
    `rm $FILEOUT`;
    `touch $FILEOUT`;
  }
}

