#!/usr/bin/perl

use IO::Handle;

open(DISP, "| cement_display");

# use spackle to cover up unsightly advertisment
# takes about 40 minutes with 33 colour pictures on netwinder with 64m RAM

$Ps = sprintf("Parameters_pairwise.txt"); # Cumulative plurality of parameters
$ps = sprintf("parameters_pairwise.txt"); # Cumulative plurality of parameters

$firstframe=399;  # always 0 for now
$lastframe=418;  # e.g. if there are 34 frames numbered 0 to 33, enter 33
# in this case Parameters should have 34 entries

# this must be aligned with the first image of the sequence, i.e. $firstframe
$medframe = sprintf("message404.ppm");
$stickyframe=404; # frame this shares the proj params with
$medframe2 = sprintf("message.ppm");
$stickyframe2= 418; # frame this shares the proj params with

for ($counter=$firstframe; $counter<=$lastframe; $counter++) {
  # allows use of Parameters_pairise, where 1st line corresponds to
  # $firstframe, and not always frame v000.jpg
  $count1 = $counter-$firstframe;
  printf("counter = $counter   count1 = $count1\n");

  $filein = sprintf("s%03d.jpg", $counter);
  $fileout = sprintf("ds%03dd.ppm", $counter);
  `rm $fileout`;
  printf("about to djpeg $filein\n");
  `djpeg $filein > deleteme_deleteme.ppm`;

  # pintegrate relative to next frame to be displayed
  `pintegrate $ps $count1 > $Ps`;
  `pchirp2nocrop deleteme_deleteme.ppm pork_reald.ppm 1 0 0 0 1 0 0 0`;

  # now cement in the replacement frame
  # e.g. to get 4th entry: head -4 Parameters_pairwise.txt | tail -1
  $framenum = $stickyframe-$firstframe+1;
  my $pchirp_parameters = `head -$framenum $Ps | tail -1`;
  print "Altering replacement frame : $pchirp_parameters\n";
  `pchirp2nocrop $medframe pork_mediatedd.ppm $pchirp_parameters`;
  $framenum = $stickyframe2-$firstframe+1;
  my $pchirp_parameters = `head -$framenum $Ps | tail -1`;
  `pchirp2nocrop $medframe2 pork_mediatedd2.ppm $pchirp_parameters`;

  `cement -overlay $fileout pork_reald.ppm pork_mediatedd.ppm pork_mediatedd2.ppm`;
  system("xv $fileout -geometry +0+40&");

   #works ok, but white background can be unsightly so use XV for now
   #print DISP "$fileout 1";
   #print DISP "\r";
   #DISP->autoflush(1);

}

