#!/usr/bin/perl

# takes about 40 minutes with 33 colour pictures on netwinder with 64m RAM

$Ps = sprintf("Parameters_pairwise.txt"); # cumulative, plurality of parameters


if ($#ARGV < 0) {
  printf("Use: pchirp2nocrop.pl v???.jpg # or use gash\n");
  printf("     pchirp2nocrop.pl also autodetects jpg or ppm\n");
  die "     ERROR: YOU MUST SPECIFY SOME FILENAMES TO BE DECHIRPED$!\n";
}

for ($counter=0; $counter<=$#ARGV+1-1; $counter++) {
  # $#ARGV is -1 if no arguments given; is 0 if 1 argument given, etc...
  $filein = $ARGV[$counter];
  $periodposition = rindex($filein,"."); # right index, period from right
  $postfix = substr($filein,$periodposition+1,3); # 2 char, e.g. JP or jp
  $postfix =~ tr/[A-Z]/[a-z]/;

  $fileout = substr($filein,0,$periodposition); # before period
  $fileout = $fileout."d".".pnm"; 
  printf("fileout is %s\n", $fileout);

  #if it's JPEG, jpeg, JPG, or jpg:
  if (($postfix eq "jpg") || ($postfix eq "jpe")) {
     `djpeg $filein > deleteme_deleteme.pgm`;
     $filein = "deleteme_deleteme.pgm";
  }

  # allows use of Parameters_pairise, where 1st line corresponds to
  # $firstframe, and not always frame v000.jpg
  # thus the following 2 lines are in case sequence doesn't start at 0
  # hand-edit $firstframe in case different than 0
  #  $firstframe = 0;
  # $count1 = $counter-$firstframe+1;  # the line it pulls from the file
  # printf("counter = $counter   count1 = $count1\n");

  # open file and write header
  #`head -$count1 $Ps | tail -1 > $P`; # previously i had this stored as file
  # e.g. to get 4th entry: head -4 Parameters_pairwise.txt | tail -1
  $count1 = $counter+1;
  my $pchirp_parameters = `head -$count1 $Ps | tail -1`; # stored as variable
  chomp $pchirp_parameters;
  printf("pchirp2nocrop.pl: about to pchirp2nocrop $filein $fileout $pchirp_parameters\n");
  system("pchirp2nocrop $filein $fileout $pchirp_parameters");

}

