#include <math.h>
#include <bits/nan.h>
/* NB:  supposedly nan.h is included from math.h when -std=c99 is on the
 *      gcc compile line but that doesn't work so its included it directly.
 *      Not having this line makes nan become unreliable, sometime it is
 *      "nan" sometimes it is -107... 
 *      */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include <fcntl.h>
#include <assert.h>
#include <zlib.h>
#include <ctype.h>
#include "cement.h"
#include "pnmutils.h"
#include "file.h"
#include <jpeglib.h>

/* Functions need in the library and the executable */
static inline double createValue(unsigned char a,double weight);
static inline double createValueNaN(unsigned char a,double weight);
static inline double createCertValue(unsigned char r, double rweight,
                                     unsigned char g, double gweight,
                                     unsigned char b, double bweight);

static int verbose=0;
static double powLookupTable[256];
static double certLookupTable[256];
static double exponent = EXPONENT;
static int certaintyflag = 0;
static int kinputflag = 0;

#ifndef OBJECT_COMPILE
/* Functions only needed in the executable */
void usage(char *string);
void parse_commandline(int argc, char ** argv,
                       char ** input_filename,
                       double *R,
                       double *G,
                       double *B,
                       char ** output_filename,
                       char ** lut_filename,
                       char ** certlut_filename,
                       double *k);
void mystatus_lut(char *action, char *filename, char *lut, double R,double G, double B, double complete);
#endif

void readlut(char *lutfilename, double *lut);
int cementinit(char *input_filename,
               char *dest_filename,
               double R,
               double G,
               double B,
               double k,
               char* command,
               void (*status)(char *action, char *filename, double R,double G, double B, double complete)
              )
{
  return cementinit_lut(input_filename, dest_filename, NULL,
           (char*)NULL, R, G, B, k, command, status, NULL);
}

/* set one of the status functions to NULL when calling */
int cementinit_lut(char *input_filename,
               char *dest_filename,
               char *lut_filename,
               char *certlut_filename,
               double R,
               double G,
               double B,
               double relative_gain,
               char* command,
               void (*status)(char *action, char *filename, double R,double G, double B, double complete),
               void (*lutstatus)(char *action, char *filename, char*lut, double R,double G, double B, double complete)
              )
{
    struct image_params a_params={NULL,0,0,0,0};
    File * a, * dest;
    unsigned char *a_pixel;
    double *out_pixel;
    int i,j,k;

    /* Timing measurments */
    struct timeval timeValStart;
    struct timeval timeValEnd;
    struct timezone timeZone;
    int minutes;
    double seconds=0.0;
#ifdef GET_TIME_MEASUREMENTS
    struct timeval runTimeStart;
    struct timeval runTimeStop;
    double fileReadTime=0.0;
    double fileWriteTime=0.0;
    double computeTime=0.0;
#endif
  
    int number_pixels_per_fop = 3036;
    int number_pixels_per_read=0;
    int number_pixels_per_write=0;
    int channels_per_pixel_read=0;
    int channels_per_pixel_write=0;
    unsigned int numberOfPixels;
    char string[MAX_STRING_LENGTH];
    unsigned int image_ptr=0;  /* NB: this ``ptr'' is an array index */
 

    a_params.filename=input_filename;

    if ((a=fileopen(a_params.filename, "r"))==NULL)
    {
        fprintf(stderr, "Unable to open %s.\n", a_params.filename);
        exit(EXIT_FAILURE);
    }

    /* maali may 9 2000 */
    if(lut_filename !=NULL) 
    {
        readlut(lut_filename,powLookupTable);
    }

    if(certaintyflag == 1 )
    {
        readlut(certlut_filename, certLookupTable);
    }

    if (dest_filename==NULL)
    {
        fprintf(stderr, "ERROR: There is no destination file.\n");
        exit(EXIT_FAILURE);
    }

    if ((dest=fileopen(dest_filename, "w"))==NULL)
    {
        fprintf(stderr, "Unable to open %s.\n", dest_filename);
        exit(EXIT_FAILURE);
    }


    if(isJpegFile(a)==0)
    {
        get_image_params(a, &a_params);

        if (a_params.type=='6')
            channels_per_pixel_read=3;
        else
     if (a_params.type=='5')
            channels_per_pixel_read=1;
        else 
        {
            fprintf(stderr, "Input image must be type P5 or P6 and it is of type P%c\n",a_params.type);
            exit(EXIT_FAILURE);
        }


    }
    else
    {
        a_params.type='6';
        a_params.max_val=255;
        channels_per_pixel_read=3;
        
        if(read_JPEG_file (a_params.filename)==0)
        {
            printf("ERROR: File %s does not exist\n",a_params.filename);
            exit(0);
        }
        
        image_ptr=0;
        a_params.width=image_width;
        a_params.height=image_height;
    }

    /* determine if an extra write channel is needed to hold certainty */
    if( certaintyflag == 1 )
            channels_per_pixel_write = channels_per_pixel_read + 1;
    else
            channels_per_pixel_write = channels_per_pixel_read;

    /* initialize array (buffer) sizes, based on image types */
    number_pixels_per_read  = number_pixels_per_fop;
    number_pixels_per_write = 
        number_pixels_per_fop*channels_per_pixel_write/channels_per_pixel_read;
    //fprintf(stderr, "number_pixels_per_write %d\n", number_pixels_per_write );
    a_pixel = (unsigned char *)malloc( number_pixels_per_read );
    out_pixel = (double *) malloc( sizeof(double)*number_pixels_per_write );


    if (certaintyflag==1)
      sprintf(string, "P%c\n", 'C');
    else if (a_params.type=='6')
      sprintf(string, "P%c\n", 'A');
    else if (a_params.type=='5')
      sprintf(string, "P%c\n", '9');

    filewrite(string,sizeof(unsigned char),strlen(string),dest);

    if( a_params.mOffset != 0) {
      sprintf(string, "# MOffset %d\n", a_params.mOffset);
      filewrite(string,sizeof(unsigned char),strlen(string),dest);
    }
    if( a_params.nOffset != 0) {
      sprintf(string, "# NOffset %d\n", a_params.nOffset);
      filewrite(string,sizeof(unsigned char),strlen(string),dest);
    }

//    fileclose(dest);
//    exit(0);

    sprintf(string, "# %s %s %f %f %f -o %s\n",command,input_filename,R,G,
            B,dest_filename);
    filewrite(string,sizeof(unsigned char),strlen(string),dest);

    //sprintf(string, "%d %d\n%d\n%d\n%f\n",a_params.width,
    //        a_params.height, a_params.max_val,1,(float)exponent);
    sprintf(string, "%d %d\n%d\n%d\n",a_params.width,
            a_params.height, a_params.max_val,1);
    filewrite(string,sizeof(unsigned char),strlen(string),dest);

    if( kinputflag == 1 ) {
      sprintf(string, "%f\n",(float)relative_gain);
    }
    else{
      sprintf(string, "%f\n",(float)exponent);
    }
    filewrite(string,sizeof(unsigned char),strlen(string),dest);


#ifdef SILENT_RUN
//    printf("Init %s (%s) %d %d %d\r",a_params.filename, lut_filename, (int)R,(int)G,(int)B);
#else

    printf("Initilizing Lightspace from file: \"%s\",",a_params.filename);
    if (lut_filename!=NULL) printf("    Using LookUp Table from file: \"%s\",",lut_filename);
    printf(" P%c, %dx%d, Channels_per_pixel: %d, ",a_params.type,a_params.width,a_params.height,channels_per_pixel_read);

    printf("R=%7.3f ",R);
    printf("G=%7.3f ",G);
    printf("B=%7.3f\n",B);
#endif
    if( kinputflag == 1 ) {
      fprintf(stderr, "using k=%g to multiply in lightspace\n", relative_gain); 
      R=relative_gain*R;
      G=relative_gain*G;
      B=relative_gain*B;
    }
    
    /* Start Timer */
    if(gettimeofday(&timeValStart,&timeZone)==-1)
    {
        fprintf(stderr,"Error getting the time\n");
        exit(0);
    }
    numberOfPixels=a_params.width*a_params.height;
    fprintf(stderr, "%d = %d x %d\n",numberOfPixels, a_params.width, a_params.height);

    if(((float)numberOfPixels/number_pixels_per_read)!=(int)((float)numberOfPixels/number_pixels_per_read))
    {
        if(verbose)
            printf("\nERROR: The number of pixels %d is not evenly divisible by %d. ",numberOfPixels,number_pixels_per_read);

        numberOfPixels=(int)((float)numberOfPixels/number_pixels_per_read)*
                number_pixels_per_read;
        if(verbose)
            printf("We will go up to %d pixels.\n",numberOfPixels);
    }

    for(i=0;i<numberOfPixels;i+=number_pixels_per_read)
    {
        if(i%(3*number_pixels_per_read)==0)
    {
            if(status!=NULL)
                status("Init",a_params.filename,R,G,B,(double)100*i/numberOfPixels);
            if(lutstatus!=NULL)
                lutstatus("Init",a_params.filename,lut_filename,R,G,B,(double)100*i/numberOfPixels);
    }

        
#ifdef GET_TIME_MEASUREMENTS
        gettimeofday(&runTimeStart,&timeZone);
#endif

        if(isJpegFile(a)==0)
            fileread(a_pixel, sizeof(unsigned char), number_pixels_per_read, a);
        else
        {
            memcpy(a_pixel,&image_buffer[image_ptr], number_pixels_per_read);
            image_ptr+=number_pixels_per_read;
        }

#ifdef GET_TIME_MEASUREMENTS
        gettimeofday(&runTimeStop,&timeZone);

        seconds=(double)runTimeStop.tv_sec+(double)runTimeStop.tv_usec/1000000;
        seconds-=(double)runTimeStart.tv_sec+(double)runTimeStart.tv_usec/1000000;
        fileReadTime+=seconds;

        gettimeofday(&runTimeStart,&timeZone);
#endif
        
        for(j=0, k=0; j<number_pixels_per_read;
            j+=channels_per_pixel_read, k+=channels_per_pixel_write)
        {
            out_pixel[k]=createValue(a_pixel[j],R);
            out_pixel[k+1]=createValue(a_pixel[j+1],G);
            out_pixel[k+2]=createValue(a_pixel[j+2],B);

            /* add on certainty channel */
            if( certaintyflag == 1 )
                out_pixel[k+3]=createCertValue(a_pixel[j], R,
                                               a_pixel[j+1], G,
                                               a_pixel[j+2], B);
        }
#ifdef GET_TIME_MEASUREMENTS
        gettimeofday(&runTimeStop,&timeZone);

        seconds=(double)runTimeStop.tv_sec+(double)runTimeStop.tv_usec/1000000;
        seconds-=(double)runTimeStart.tv_sec+(double)runTimeStart.tv_usec/1000000;

        computeTime+=seconds;

        gettimeofday(&runTimeStart,&timeZone);
#endif
        
        filewrite(out_pixel, sizeof(double), number_pixels_per_write, dest);

#ifdef GET_TIME_MEASUREMENTS
        gettimeofday(&runTimeStop,&timeZone);

        seconds=(double)runTimeStop.tv_sec+(double)runTimeStop.tv_usec/1000000;
        seconds-=(double)runTimeStart.tv_sec+(double)runTimeStart.tv_usec/1000000;
        fileWriteTime+=seconds;
#endif
    }

    if(numberOfPixels!=(a_params.width*a_params.height))
    {
        if(verbose)
            printf("Cleanup on pixels %d to %d\n",numberOfPixels,a_params.width*a_params.height);

        for(i=numberOfPixels;i<a_params.width*a_params.height;i++)
        {
            if(isJpegFile(a)==0)
                fileread(a_pixel, sizeof(unsigned char),channels_per_pixel_read, a);
            else
            {
                memcpy(a_pixel,&image_buffer[image_ptr],channels_per_pixel_read);
                image_ptr+=channels_per_pixel_read;
            }

            out_pixel[0]=createValue(a_pixel[0],R);
            out_pixel[1]=createValue(a_pixel[1],G);
            out_pixel[2]=createValue(a_pixel[2],B);

            if( certaintyflag == 1)
                out_pixel[3]=createCertValue(a_pixel[0],R,
                                            a_pixel[1],G,
                                            a_pixel[2],B);
            filewrite(out_pixel, sizeof(double), channels_per_pixel_write, dest);
        }       
    }

    /* End timer */
    if(gettimeofday(&timeValEnd,&timeZone)==-1)
    {
        printf("Error getting the time\n");
        exit(0);
    }

    {
      static int counter=0;
    while (!fileeof(a))
    {
      if(isJpegFile(a)==0)
    fileread(a_pixel, sizeof(char),channels_per_pixel_read, a);
      else
        {
      memcpy(a_pixel,&image_buffer[image_ptr],number_pixels_per_read);
      image_ptr+=number_pixels_per_read;
        }
      
      if(fileeof(a))
    break;
      out_pixel[0]=createValue(a_pixel[0],R);
      out_pixel[1]=createValue(a_pixel[1],G);
      out_pixel[2]=createValue(a_pixel[2],B);
      if( certaintyflag == 1)
          out_pixel[3]=createCertValue(a_pixel[0],R,
                                       a_pixel[1],G,
                                       a_pixel[2],B);
     //printf("EP A: %d %d %d\t",a_pixel[0],a_pixel[1],a_pixel[2]);
     //printf("OUT: %f %f %f %12.12f\n",out_pixel[0],out_pixel[1],out_pixel[2], out_pixel[3]);
      filewrite(out_pixel, sizeof(double), channels_per_pixel_write, dest);
      counter++;
    }
    //fprintf(stderr ,"unknown %d extra operations\n",counter);
}
    
    fileclose(a);
    fileclose(dest);

    seconds=(double)timeValEnd.tv_sec+(double)timeValEnd.tv_usec/1000000;
    seconds-=(double)timeValStart.tv_sec+(double)timeValStart.tv_usec/1000000;

#ifdef GET_TIME_MEASUREMENTS
    printf("%f s doing File Read %f%%\n",fileReadTime,100*fileReadTime/seconds);
    printf("%f s doing File Writes %f%%\n",fileWriteTime,100*fileWriteTime/seconds);
    printf("%f s doing Computation %f%%\n",computeTime,100*computeTime/seconds);
    printf("%f s doing Timing and looping\n",seconds-fileReadTime-fileWriteTime-computeTime);
#endif
    
    if(seconds>60)
    {
        minutes=seconds/60;
        seconds=seconds-minutes*60;
    }
    else
        minutes=0;

    if(verbose || GET_RUN_TIME)
    {
#ifndef SILENT_RUN
        if(minutes==1)
            printf("Run Time is about %d minute %f seconds.\n",minutes,seconds);
        else
            printf("Run Time is about %d minutes %f seconds.\n",minutes,seconds);
#else
            if(status!=NULL)
                status("Init",a_params.filename,R,G,B,(double)100);
            if(lutstatus!=NULL)
                lutstatus("Init",a_params.filename,lut_filename,R,G,B,(double)100);
//        printf("Init %s (%s) %d %d %d %4.2f(s)\n",a_params.filename,lut_filename,(int)R,(int)G,(int)B,minutes*60+seconds);
#endif
    }

    if(isJpegFile(a)==1)
        free(image_buffer);

    return(EXIT_SUCCESS);
}

/* if k is being used, weight should be R*k by this point */
static inline double createValue(unsigned char a,double weight)
{
    return(weight*powLookupTable[a]);
}

static inline double createValueNaN(unsigned char a,double weight)
{
    if( a == 255) return NAN;
    //if( a == 255) return 0.00000000000000001;
    //if( a == 255) return NAN;
    return(weight*powLookupTable[a]);
}

/* this function takes the RGB values and weights and returns a 
 * certainty from the certLookupTable */
static inline double createCertValue(unsigned char r, double rweight,
                   unsigned char g, double gweight,
                                     unsigned char b, double bweight)
{
    if( b==255) {
        return 0;
    }
    /*
    fprintf(stderr, "gval = %d\n", (unsigned int)rint(0.299*(double)r*(double)rweight + 
                         0.587*(double)g*(double)gweight + 
                         0.114*(double)b*(double)bweight) );
    */
/*
    assert(certLookupTable[
    (unsigned char )rint(0.299*(double)r*(double)rweight + 
                         0.587*(double)g*(double)gweight + 
                         0.114*(double)b*(double)bweight)
    ] > 0);
*/
    /* convert weighted RGB to greyscale */
    return(certLookupTable[
    (unsigned char )rint(0.299*(double)r*(double)rweight + 
                         0.587*(double)g*(double)gweight + 
                         0.114*(double)b*(double)bweight)
    ]);
}

#ifndef OBJECT_COMPILE
int main(int argc, char ** argv)
{
    char * dest_filename=NULL;
    char * input_filename=NULL;
    char * lut_filename=NULL;
    char * certlut_filename=NULL;
    double relative_gain=1;
    double R,G,B;


    parse_commandline(argc, argv, &input_filename, &R,&G,&B,&dest_filename,&lut_filename, &certlut_filename,&relative_gain);

    return(cementinit_lut(input_filename,dest_filename,lut_filename,certlut_filename,R,G,B,relative_gain,argv[0],NULL,mystatus_lut));
}

void mystatus_lut(char *action, char *filename, char*lut_filename, double R,double G, double B, double complete)
{
    if (lut_filename!=NULL) printf("%s %s (%s) %d %d %d %d%%\r",action,filename,lut_filename,(int)R,(int)G,(int)B,(int)complete);
    else printf("%s %s %d %d %d %d%%\r",action,filename,(int)R,(int)G,(int)B,(int)complete);
    fflush(stdout);
    if((int)complete==100)
    printf("\n");
}

void usage(char *string)
{
    fprintf(stderr, "Use: %s [Imagespace file] <R> <G> <B> -o [Lightspace file] \n"
            "\t [-lut [Imaging Device Response file]]\n"
            "\t [-clut Certainty Lookup Table]\n"
            "\t [-k Relative Gain]\n",string);
    fprintf(stderr, " [Imagespace file] is a ppm file that will start a lightspace.\n");
    fprintf(stderr, " <R>=Float for Red weight.\n");
    fprintf(stderr, " <G>=Float for Green weight.\n");
    fprintf(stderr, " <B>=Float for Blue weight.\n");
    fprintf(stderr, " [LightSpaceFile] is a Portable Lightspace Map (plm) that will be created.\n");
    fprintf(stderr, " [LookUp Table file] (optional, lut) specifies a map from \n");
    fprintf(stderr, " imagespace to lightspace; if none specified, a default map is used.\n");
    exit(EXIT_SUCCESS);
}

void parse_commandline(int argc, char ** argv,
                       char ** input_filename,
                       double *R,
                       double *G,
                       double *B,
                       char ** output_filename,
                       char ** lut_filename,
                       char ** certlut_filename,
                       double *relative_gain) 
{
  int diff, exp, i;
  char c;

    if (argc<7)
    {
        fprintf(stderr,"error: number of input arguments was only %d\n",argc-1);
        usage(argv[0]);
    }

    *input_filename=(char*)strdup(argv[1]);
    sscanf(argv[2],"%lf",R); /* sscanf does not recognize %g, must be %lf */
    sscanf(argv[3],"%lf",G); /* sscanf does not recognize %g, must be %lf */
    sscanf(argv[4],"%lf",B); /* sscanf does not recognize %g, must be %lf */

    /* Pouya 13/01/2003: Fix crasher bugs by checking the length of the string in most of the cases below */

    if ((strlen(argv[5])>=2) && (argv[5][0]!='-' || argv[5][1] !='o'))
        usage(argv[0]);

    *output_filename=(char *)strdup(argv[6]);

    /* maali may 9 2000 */
    if(argc>7)
    {      
      for(i=7 ; i<argc ; i++ ) { 

        if((strlen(argv[i])>=4)&&(argv[i][0]=='-')&&(argv[i][1]=='l')&&
           (argv[i][2]=='u')&&(argv[i][3]=='t'))
        {
            if (argc <= i+1) /* Sanity check - Pouya 13/01/2003 */
            {
                fprintf(stderr, "-lut must be followed by a digit/string\n");
                exit(1);
            }

            c = argv[i+1][0];
     //     diff = c - '0';
     //     if ( diff >= '0' || diff <= '9') {
            if (isdigit(c))
            {
                *lut_filename = (char*) malloc(50 * sizeof(char));
                exponent = atof(argv[8]);
                exp = rint(exponent);
                exponent /= 10.0;
                sprintf(*lut_filename, "powLookup%d.txt", exp);
            }
            else
            {
                *lut_filename=(char *)strdup(argv[i+1]);
                fprintf(stderr,"%s: using lut %s\n", argv[0],*lut_filename);
            }
        }
        else if((strlen(argv[i])>=5) && (argv[i][0]=='-')&&(argv[i][1]=='c')&&
                 (argv[i][2]=='l')&&(argv[i][3]=='u')&& 
                 (argv[i][4]=='t'))
        {         
            if (argc <= i+1) /* Sanity check - Pouya 13/01/2003 */
            {
                fprintf(stderr, "-clut must be followed by a string\n");
                exit(1);
            }

            *certlut_filename=(char *)strdup(argv[i+1]);
            certaintyflag = 1;
            fprintf(stderr, "%s: creating certainty PLM\n", argv[0]);
        }
        else if ((strlen(argv[i])>=2) &&(argv[i][0]=='-')&&(argv[i][1]=='k'))
        {
            if( !(argc >i+1) )
            {
                fprintf(stderr,"%s: format error: -k specified but no value given.\n",argv[0]);
                exit(1);
            }
            if (sscanf(argv[i+1],"%lg\n",relative_gain) != 1)
            {
                fprintf(stderr,"%s: format error: -k specified but no value given.\n", argv[0]);
                exit(1);
            }
            kinputflag = 1;
        }
      }  /* end parser for loop */
    }
    else 
    {


    if (argc == 7)        
      {
        *lut_filename = (char*) malloc(50 * sizeof(char));
        exp = rint(exponent*10);
        sprintf(*lut_filename, "powLookup%d.txt", exp);
      }
    else
      usage(argv[0]);
      }
}
#endif


/* ===================================================================== */
/* ===================================================================== */
/* ===================================================================== */
/* Readlut - reads a given lookup table. */
/* we have two types of lookup tables.  One is the powLookup lut, which
 * has the value of the exponent (used to generate the lut) on the first 
 * line. 
 * The other type of LUT is a certainty lut.  This has no first */

void readlut(char *lutfilename, double *lut)
{
  /* some variables used in reading a text file lut */
  FILE *lutfile;
  int lutsize=256;
  float p;
  int i;

  if(lutfilename !=NULL) 
    {
      if ((lutfile = fopen(lutfilename, "r")) == NULL)
    {
      fprintf(stderr, "Unable to open %s.\n", lutfilename);
      exit(EXIT_FAILURE);
      } 
      else 
      {
        fscanf(lutfile, "%f", &p);
        for (i=0; i<lutsize; i++) {
          fscanf(lutfile, "%lf", &(lut[i]));
          //fprintf(stderr, "lut[%d]=%12.12f\n", i,lut[i] );
        }
        
        if (i != lutsize) {
          fprintf(stderr, "Incomplete read of LUT. Numread: %d\n", i);
          fclose(lutfile);
          exit(1);
        }
      }
    fclose(lutfile);
      }
}
