#include<fftw.h>
#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<pgm.h>
#include<ppm.h>
#include<assert.h>

#define THRESHOLD 0
/* It has been a long time since I did any real programming. However, 
 * I will attempt it here. I am trying to write a program which will 
 * take two pictures and cross-correlate them with ffts. For that
 * I am using fftw, a library of functions which perform ffts quickly
 * and efficiently (or so they claim). I will take, for now, simple
 * png input and output, and leave the conversion to other utilities.
 * For this, I am going to use Steve Mann's Matlab code as a basis.*/

/* This code implements the fft for video orbits. It takes two 
 * images as input, and returns the translational coordinates as calculated
 * by the FFTW algorithm...*/

/*
Steve,
You have to 'touch wise_for wise_rev'
in order for the stuff to work if there's no wisdom in the directory.
Eric
*/

fftw_complex conj(fftw_complex in);
double mod(fftw_complex in);
double hanning(int n, int N);
fftw_complex mult(fftw_complex a, fftw_complex b);

int main(int numargs, char * nameargs[])
{
   fftw_complex *a, *b;
   fftw_complex *A, *B;
   fftw_complex *q, *Q;
   double *out;     /*To hold the comparison*/
   double max, max_re, max_im;      /*which stores the max value of the array*/
   double tmpmod;
   float *modmap;
   int i, j, k, l, index;               /*indices*/
   int arraysize;
   int rows, cols, in1_cols, in1_rows, in2_cols, in2_rows, format, rowstride;	
   int avg_grey;
   fftwnd_plan plan_forward, plan_reverse;
   gray **in1;
   gray **in2;
   gray **out_gray;
   gray grays;

/* I want to make a program that takes two images from the command
  * line and spits out the offsets as a first guess for 
  * estpchsirp */
		
   FILE *img1, *img2, *for_wis, *rev_wis, *outpic;

   if(numargs!=3){
      fprintf(stderr,"Usage: %s img1.pgm img2.pgm\n",nameargs[0]);
      exit(1);
   }
   img1 = fopen(nameargs[1],"r");
   img2 = fopen(nameargs[2],"r");
   pgm_init( &numargs, nameargs);
   in1 = pgm_readpgm(img1, &in1_cols, &in1_rows, &grays);
   in2 = pgm_readpgm(img2, &in2_cols, &in2_rows, &grays);
   if( in1_cols != in2_cols || in1_rows != in2_rows ) {
      fprintf(stderr, "Error: Image sizes do not match\n");
      exit(1);
   }
   else {
      rows = in1_rows;
      cols = in1_cols;
      rowstride = cols; /* explanatory*/
      fprintf(stdout, "Comparing images sizes %d rows by %d cols\n",rows, cols);
   }

   a = (fftw_complex*)calloc(1,sizeof(fftw_complex)*rows*cols);
   A = (fftw_complex*)calloc(1,sizeof(fftw_complex)*rows*cols);
   b = (fftw_complex*)calloc(1,sizeof(fftw_complex)*rows*cols);
   B = (fftw_complex*)calloc(1,sizeof(fftw_complex)*rows*cols);
   Q = (fftw_complex*)calloc(1,sizeof(fftw_complex)*rows*cols);
   q = (fftw_complex*)calloc(1,sizeof(fftw_complex)*rows*cols);
   modmap = (float*)calloc(1,sizeof(float)*rows*cols);
   out_gray = (gray**)calloc(1,sizeof(gray*)*rows);	

   for(i=0;i<rows;i++){
      out_gray[i] = (gray*)calloc(1,sizeof(gray)*cols);
   }
		
   out = (double*)calloc(1,sizeof(double)*rows*cols);

   /* check for forward wisdom file, if it DNE, create it... */
   if (((for_wis = fopen("wise_for","r")))==NULL){
      system("touch wise_for");
      for_wis = fopen("wise_for","r");
   }
		
   fftw_import_wisdom_from_file(for_wis);
   printf("got wisdom?\n");
   fclose(for_wis);

   /* Create plan for forward fft, and store to for_wis */	
   plan_forward = fftw2d_create_plan(rows,cols, FFTW_FORWARD, FFTW_ESTIMATE );
   for_wis = fopen("wise_for","w");
   fftw_export_wisdom_to_file(for_wis);
   printf("got rid of wisdom\n");
   fclose(for_wis);

   /* Do the same steps for the reverse FFT */
   rev_wis = fopen("wise_rev","r");
   if(rev_wis == NULL){
      system("touch wise_rev");
      rev_wis = fopen("wise_rev","r");
   }
   fftw_import_wisdom_from_file(rev_wis);
   printf("got rev wisdom\n");
		
   fclose(rev_wis);
   plan_reverse = fftw2d_create_plan(rows,cols, FFTW_BACKWARD, FFTW_ESTIMATE);
   rev_wis=fopen("wise_rev","w");
   fftw_export_wisdom_to_file(rev_wis);
   printf ("GOt rid of rev wisdome \n");
   fclose(rev_wis);

   /*Now we need to get the pictures in img1 and 2 into the arrays
    * a and b. This is done in the following for loop
    */
   for (i=0;i<rows;i++){
      index=rowstride*i;
      for(j=0;j<cols;j++){
         c_re(a[index]) = 

(double)(in1[i][j]* hanning(i,rows)*
hanning(j,cols));


        c_re(b[index]) = 

(double)(in2[i][j]* 
hanning(i,rows)*hanning(j,cols));


        index++;


      }
   }
		
   fftwnd_one(plan_forward, (fftw_complex*)a, (fftw_complex*)A); 
/*Not crack smoking; it's so I can refer to the arrays by index later*/

   fftwnd_one(plan_forward, (fftw_complex*)b, (fftw_complex*)B); 
/*Now the ffts should be in A and B*/
/* We want to make find the maximum value of the cross-
 * correlation. This is given by mag(A[i][j]*B[i][j])/
 * (mag(A[i][j])*mag(B[i][j]))^exponent. So we need to find 
 * what the maximum value of this is, and spit out its co-
 * ordinates. */

   index=0;
   for(i=0;i<rows;i++){ 
      for(j=0;j<cols;j++){
         if(  mod(A[index]) < THRESHOLD ) {
            c_re(Q[index])=0;
            c_im(Q[index])=0;
            index++;
            continue;
         }

         Q[index] = (mult(conj(B[index]),A[index]));
         tmpmod = (mod(A[index])*mod(B[index]));
         c_re(Q[index])/=tmpmod;
         c_im(Q[index])/=tmpmod;
         index++;

/*
         c_re(Q[index]) = 
            c_re(B[index])*c_re(A[index])+
            c_im(B[index])*c_im(A[index]);
         tmpmod = (mod(A[index])*mod(B[index]));
         c_re(Q[index])/=tmpmod;
         c_im(Q[index])=0;
         index++;
*/

      }
   }
/* Now we need to take the Q matrix and apply the reverse fft
 * to it. This is as simple as making a reverse plan and 
 * using it. */
   fftwnd_one(plan_reverse, (fftw_complex*)Q,(fftw_complex*)q);

/* we need to renormalize mod(q) to have a maximum of 255
 * so that means that we go through, find the max, set that 
 * max equal to 255, and scale everything else.
 * Want to avoid modulus to check unsquared vals before
 * doing a modulus
 */

   index=0;
   max = 0;
   max_re = max_im = 0;
   for(i=0;i<rows;i++){
      for(j=0;j<cols;j++){
//         if( c_re(q[index]) > max_re || c_im(q[index]) > max_im ) {
            modmap[index] = mod(q[index]);
	    if(max<=modmap[index]){
               max =modmap[index];
               k = i;
               l = j;
               max_re = c_re(q[index]);
               max_im = c_im(q[index]);
            }
//         }
         index++;
      }
   }
   printf("Found max %lf at %d, %d\n\n",max,k,l);

/* Now the max is in double max, and its location is in k,l. 
 * We need to renormalize the matrix and, cast into gray and 
 * write out the pgm file...*/

   index=0;
   for(i=0;i<rows;i++){
      for(j=0;j<cols;j++){
         (out_gray)[i][j] = (gray)((modmap[index]*255)/max);
         index++;
      }
   }

/*
   (out_gray)[k][l] = 255;
   (out_gray)[k+1][l] = 255;
   (out_gray)[k+2][l] = 255;
   (out_gray)[k-1][l] = 255;
   (out_gray)[k-2][l] = 255;
   (out_gray)[k][l-1] = 255;
   (out_gray)[k][l-2] = 255;
   (out_gray)[k][l+1] = 255;
   (out_gray)[k][l+2] = 255;
*/


   

/*Now the output q is an inverse transform of Q, which we 
 * should be able to look at and find the max of...*/
		
   outpic = fopen("est_trans_fft2_distribution.pgm","w");
		
   pgm_writepgm(outpic, out_gray, cols, rows, grays, 1);
		
   printf("wrote a pgm\n");
   fclose(outpic);
		
// need smart hack here to get it working
// aaaaaaaaaaaa
   if (k>rows/2)
     k = k-rows;

   if (l>cols/2)
     l = l-cols;

   /* I'm convinced this is wrong - 
    * how can we assume the direction of motion?, ie:
    * if we have a dot somewhere, from what corner did we approach it? 
    */		
   assert(abs(l)<cols);
   fprintf(stdout,"1 0 %12g 0 1 %12g 0 0\n",((double)(-k))/rows,((double)(-l))/cols);

   free(a);
   free(b);
   free(A);
   free(B);
   free(q);
   free(Q);
   free(out);
   /*Insert X code here*/
}

double mod(fftw_complex in){
		double out;
		out = sqrt(c_re(in)*c_re(in) + c_im(in)*c_im(in));
		return(out);
}


fftw_complex conj(fftw_complex in){
		fftw_complex out;
		c_re(out)=c_re(in);
		c_im(out)= -c_im(in);
		return(out);
}

double hanning(int n, int N){
		/*printf("n = %d, N = %d, window = %g\n",n, N,(0.5 - 0.5*cos(2*M_PI*(((double)n)/((double)N)))));*/
		return (0.5 - 0.5*cos(2*M_PI*(((double)n)/((double)N))));
		printf("Hanning also scnanning\n");
}

fftw_complex mult(fftw_complex a, fftw_complex b){
		fftw_complex out;
		c_re(out)=c_re(a)*c_re(b) - c_im(a)*c_im(b);
		c_im(out)=c_re(a)*c_im(b) + c_im(a)*c_re(b);
		return(out);
}
