#ifndef __IMG_WARP__
#define __IMG_WARP__
#include "mat_util.h"

/* a general function intended to handle any type of
 * image transformation definable by a dst_to_src 2d resampling
 * function. very special care is taken to properly handle
 * various degrees of subpixel interpolation and various levels of 
 * macro pixel antialiasing where required.
 */
void img_resample(Image *src,
	          int src_vdim, int src_hdim,
	      
	          int interp_order, /* 0, 1, 3 */
	          int sample_level, /* -1, 0, 1, 8 */
	      
	          Image *dst,
	          int dst_vdim, int dst_hdim,
		  double/*Image*/ nan_for_background_grey_level,
                  int output_scaling
		 );

#endif

