#ifndef _MOTION_H_
#define _MOTION_H_

#include <X11/Xlib.h>

typedef struct {
  int NO_TRANSLATION;
  int NO_ZOOM;
  /* Following two options are mutually exclusive */
  int YES_ISOTROPIC;   /* Forces X and Y zoom to be the same */
  int ONLY_ROTATION;   /* Constrain A matrix to be rotation matrix */
  int NO_SHEAR;        /* No rotation at all */
  int NO_CHIRP;
} EstimatorParameters; /* Note that all-zero structure yields
			  the original behavior of the estimator */

Var * find_motion_parameters(Var *, Var *, Var *,
			     int, int, double *,
			     int, int, int, EstimatorParameters *,
			     Pixmap );
void est_pchirp2(Var *, Var *, Var *);
void pcompose(Var *, Var *, Var *);
double calculate_difference(Var *, Var *, Var *, int, int);

#endif
