#ifndef _PNMUTILS_H_
#define _PNMUTILS_H_

#include <stdio.h>
#include <zlib.h>
#include "file.h"
// cementinit makes headers that look like
//
// PA
// # MOffset 107
// # NOffset -41
// # cementinit v09d.pnm 1.000000 1.000000 1.000000 -o v09d.plm
// 641 487
// 255 
// 1    # this here is # of images I think
// 2.200000   # this here is exponent, or better it could be k

/* these are from PNMImageOffsetable.h */
/* use the define to prevent namespace collision during merger */
#ifndef _PNMIMAGEOFFSETABLE_H_
#define PNM_ERROR -1
#define PNM_FILE_ERROR -4
#define M_OFFSET "MOffset"
#define N_OFFSET "NOffset"
#endif

struct image_params {

  char * filename;
  int width;
  int height;
  int mOffset; 
  int nOffset;
  /* max_val is the maximum colour component value - often 255 */
  int max_val;
  /* type is either '5' to indicate a P5 file or '6' to indicate a P6 file */
  int type;
  unsigned int numberOfImages;
  float exponent;
};

void get_image_params(File * ifs, struct image_params * params);

void get_image_type(File * ifs, struct image_params * params);
void get_image_params_preserve_comments(File * ifs, struct image_params * params, File *ofs);
int is_plm_filename(char *fn);

#endif
