#ifndef _VIDEORBITS_H
#define _VIDEORBITS_H



#define INTERNAL_VARIABLE 0
#define IMAGE 1
#define INTERNAL_INT 2

/* - - Not a Number definitions - - */
#define NaNData /*DBL_MAX 1024000000.0*/ 512000.0 /*1048576.0 */
#define NaNImage /*DBL_MAX */512000.0
#define NaNChar 255 /* Still needed for printing to image files. */

/* - - Types - - */
//typedef float Data; //dont use yet, use double
//typedef float Image; //dont use yet, use double
typedef double Data; //dont use yet, use double
typedef double Image; //dont use yet, use double

/* - - structures - - */
struct variable
{
  const char * name;
  Data * data;     /* signed floating point values  */
  Image * image;   /* also signed floating point values */
  int magic_number;
  char lookup_table_name[255];
  int plm_field_1;
  float plm_field_2;
  int max_value;
  int channels;
  int var_type;
  int M, N;
};
typedef struct variable Var;

void run_estpchirp2m(char *theline);
void build_pseudo_sum_matrix(Var * Dt, Var * Dm, Var * Dn,
			    Var * DER,
                    Var *der);

void init_var(Var * variable, const char *name, 
	       int M, int N, int var_type, int channels,char * lookup_table);



#endif
